### 
# CGI֘ACu
###

# R[hϊCu捞
require './jcode.pl';

###
#  ͉͏
sub decode {
    local(%in);
    local($buf);
    if ($ENV{'REQUEST_METHOD'} eq "POST") {
	read(STDIN, $buf, $ENV{'CONTENT_LENGTH'});
    } else {
	$buf = $ENV{'QUERY_STRING'};
    }

    local(@pairs) = split(/&/, $buf);
    foreach (@pairs) {
	local($name, $value) = split(/=/);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	
	# R[hVtgJISϊ (R[h̓ƃTj^CWÔ)
	local($c) = &jcode::getcode(\$value);
	#print "code: $c\n";
	if ($c eq 1 || $c eq 3) {
	    &jcode::convert(\$value, 'sjis');
	}

	# ^O (Tj^CWO)
	$value =~ s/&/&amp;/g;
	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;
	$value =~ s/"/&quot;/g; # "
	$value =~ s/\r//g;
	$value =~ s/\n//g;
	
	$in{$name} = $value;
    }
    return %in;
}

###
# NbL[擾
sub getCookie {
    local($cookiekey) = $_[0];
    local(@cook) = split(/;/, $ENV{'HTTP_COOKIE'});
    foreach (@cook) {
	local($key, $val) = split(/=/);
	$key =~ s/\s//g;
	if ($key eq $cookiekey) {
	    local(%ck) = split(/<>/, $val);
	    return %ck;
	}
    }
}

###
#  NbL[ݒ
sub setCookie {
    local($cookiekey, $ck, $expday) = @_;
    
    local (@t) = gmtime(time + $expday*24*60*60);
    local ($expt) = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
			    (qw(Sun Mon Tue Wed Thu Fri Sat))[$t[6]],
			    $t[3],
			    (qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec))[$t[4]],
			    $t[5]+1900, $t[2], $t[1], $t[0]);
    
    print "Set-Cookie: $cookiekey=$ck; expires=$expt\n";
}

###
#  URLGR[h
sub url_enc {
    local($_) = @_;

    s/(\W)/'%' . unpack('H2', $1)/eg;
    s/\s/+/g;
    $_;
}

# end of cgilib
1;
